// compute determinants on various methodes
#include <MatrixLib.h>

boolean first = true;
#define taille 5

Matrix m1(taille, taille);
Matrix m2(taille, taille);
Matrix m3(taille, taille);
long t1, t2;

void setup() {
  Serial.begin(9600);
  for (int i = 0; i < taille; i++)
    for (int j = 0; j < taille; j++) {
      float v1 = random(taille * 10) + 1;
      m1.setValMat(i, j, v1);
      m2.setValMat(i, j, v1);
      m3.setValMat(i, j, v1);
    }

  m1.showMat(&Serial);
}

void loop() {
  if (first) {
    t1 = micros();
    real d1 = m1.gaussJordanDeter();
    t2 = micros();
    Serial.println("  gauss Jordan pivoting  ");
    Serial.print("determinant : ");
    Serial.println(d1);
    Serial.print("delay : ");
    Serial.print(t2 - t1);
    Serial.println(" micro s");
    Serial.println();
    t1 = micros();
    real d2 = m2.luCroutDeter();
    t2 = micros();
    Serial.println("  LU crout  pivoting  ");
    Serial.print("determinant : ");
    Serial.println(d2);
    Serial.print("delay : ");
    Serial.print(t2 - t1);
    Serial.println(" micro s");
    Serial.println();
    t1 = micros();
    real d3 = m3.deterClassic();
    t2 = micros();
    Serial.println("  classic determinant   ");
    Serial.print("determinant : ");
    Serial.println(d3);
    Serial.print("delay : ");
    Serial.print(t2 - t1);
    Serial.println(" micro s");
    Serial.println();
    first = false;
  }
}