// solves system,  compute determinants on various methodes
// on rectangular matrix 
// that contain linear coefficients , constant and solution to be computed
#include <MatrixLib.h>

boolean first = true;
#define tailley 5
#define taillex ((tailley)+2)

Matrix  m1(tailley,taillex);
Matrix  m2(tailley,taillex);
Matrix  m3(tailley,taillex);


long t1, t2;

void setup() {
  Serial.begin(9600);
  // fill matrix
  for (int i = 0; i < tailley; i++) {
    // fill line coefficients
    for (int j = 0; j < tailley; j++) {
      real v1 = random(tailley * 10) + 1;
      m1.setValMat(i,j,v1);
      m2.setValMat(i,j,v1);
      m3.setValMat(i,j,v1);
    }
    // fill constant
    real v2 = i * tailley;
    m1.setValConst(0,i,v2);
    m2.setValConst(0,i,v2);
    m3.setValConst(0,i,v2);
        
  }
  m1.clearSolution();
  m2.clearSolution();
  m3.clearSolution();
  
  Serial.println("M X = B -> M B :");

  m1.showMat(&Serial);
}


void showSolution(Matrix m)
{
  for (int i=0; i<tailley; i++) {Serial.println(m.getValSol(i));}
Serial.println();  
}

void loop() {
  if (first) {
    Serial.flush();
    t1 = micros();
    real d1 = m1.gaussJordanSolve(0);
    t2 = micros();

    Serial.println("  gauss Jordan ");
    Serial.print("determinant : ");
    Serial.println(d1);
    Serial.println("solution :");
    showSolution(m1);
    Serial.print("delay solving : ");
    Serial.println(t2 - t1);
    Serial.println();

    t1 = micros();
    real d2 = m2.luCroutSolve(0);
    t2 = micros();
    
    Serial.println("  LU crout Pivoting ");
    Serial.print("determinant : ");
    Serial.println(d2);
    Serial.println("solution :");
    showSolution(m2);
    Serial.print("delay solving : ");
    Serial.println(t2 - t1);
    Serial.println();
    
    t1 = micros();
    real d3 = m3.deterSolve(0);
    t2 = micros();

    Serial.println("  Kramer solving ");
    Serial.print("determinant : ");
    Serial.println(d3);
    Serial.println("solution :");
    showSolution(m3);
    Serial.print("delay solving : ");
    Serial.println(t2 - t1);
    Serial.println();
    first = false;
  }
}