// compute determinants on various methodes
#include <MatrixLib.h>

boolean first = true;
#define taille 5

MatrixObj m1(taille, taille);
MatrixObj m2(taille, taille);



void setup() {
  Serial.begin(9600);
  for (int i = 0; i < taille; i++)
    for (int j = 0; j < taille; j++) {
      float v1 = random(taille * 10) + 1;
      m1.setValMat(i, j, v1);
    }
}

void loop() {
  if (first) {
    Serial.println();
    Serial.println("M1=");
    m1.showMat(&Serial);

    Serial.println();
    Serial.println("M1=0.5*M1");
    m1.multiplyVal(0.5);
    m1.showMat(&Serial);

    Serial.println();
    Serial.println("M2=Identity");
    m2.identity();
    m2.showMat(&Serial);

    Serial.println();
    Serial.println("MI=M1+M2");
    m1.add(m2);
    m1.showMat(&Serial);

    Serial.println();
    Serial.println("M1 transpose");
    m1.transpose();
    m1.showMat(&Serial);

    Serial.println();
    Serial.println("M2=M1");
    m2.copy(m1);
    m2.showMat(&Serial);

    Serial.println();
    Serial.println("Invert M2");
    m2.invMatrixClassic();
    m2.showMat(&Serial);

    Serial.println();
    Serial.println("M2=M2 x M1");
    m2.multiply(m1);
    m2.showMat(&Serial);

    Serial.println();
    Serial.println("M2=M2*1E5");
    m2.multiplyVal(1E5);
    m2.showMat(&Serial);

    Serial.println();
    Serial.println("M2 zeroed to 1");
    m2.zeroed(1);
    m2.showMat(&Serial);

    Serial.println();
    Serial.println("M2 =M2*1E5");
    m2.multiplyVal(1E-5);
    m2.showMat(&Serial);

    Serial.println();
    Serial.println("M2=M2-I");
    m1.identity();
    m1.multiplyVal(-1);
    m2.add(m1);
    m2.showMat();  // by default to Serial

    Serial.println();
    Serial.println("zeroed M2 Epsilon value");
    m2.zeroed();  // default vale _Epsilon
    m2.showMat(&Serial);


    first = false;
  } else delay(100);
}