// solves system,  compute determinants on various methodes
// on rectangular matrix 
// that contain linear coefficients , constant and solution to be computed
#include <MatrixLib.h>

boolean first = true;
#define tailley 5
#define taillex ((tailley)+2)

real m1[tailley][taillex];
real m2[tailley][taillex];
real m3[tailley][taillex];


long t1, t2;

void setup() {
  Serial.begin(9600);
  // fill matrix
  for (int i = 0; i < tailley; i++) {
    // fill line coefficients
    for (int j = 0; j < tailley; j++) {
      real v1 = random(tailley * 10) + 1;
      m1[i][j] = v1;
      m2[i][j] = v1;
      m3[i][j] = v1;
    }
    // fill constant
    real v2 = i * tailley;
    m1[i][tailley] = v2;
    m2[i][tailley] = v2;
    m3[i][tailley] = v2;
    // empty solutions
    m1[i][tailley + 1] = 0;
    m2[i][tailley + 1] = 0;
    m3[i][tailley + 1] = 0;
  }
  Serial.println("M X = B -> M B :");

  showMatMat(&m1[0][0], tailley, taillex, &Serial);
}


void showSolution(real*M)
{
  for (int i=0; i<tailley; i++) {Serial.println(M[(i+1)*(taillex)-1]);}
Serial.println();  
}

void loop() {
  if (first) {
    Serial.flush();
    t1 = micros();
    real d1 = gaussJordanSolveMat(*m1,tailley,taillex,0); 
    t2 = micros();

    Serial.println("  gauss Jordan ");
    Serial.print("determinant : ");
    Serial.println(d1);
    Serial.println("solution :");
    showSolution(&m1[0][0]);
    Serial.print("delay solving : ");
    Serial.println(t2 - t1);
    Serial.println();

    t1 = micros();
    real d2 = luCroutSolveMat(*m2, tailley,taillex,0);
    t2 = micros();
    
    Serial.println("  LU crout Pivoting ");
    Serial.print("determinant : ");
    Serial.println(d2);
    Serial.println("solution :");
    showSolution(&m2[0][0]);
    Serial.print("delay solving : ");
    Serial.println(t2 - t1);
    Serial.println();
    
    t1 = micros();
    real d3 = deterSolveMat(*m3, tailley,taillex,0);
    t2 = micros();

    Serial.println("  Kramer solving ");
    Serial.print("determinant : ");
    Serial.println(d3);
    Serial.println("solution :");
    showSolution(&m3[0][0]);
    Serial.print("delay solving : ");
    Serial.println(t2 - t1);
    Serial.println();
    first = false;
  }
}